 
/*
   @06-07-2016
   @09-07-2016
   @17-07-2016
   @19-08-2016
   CW callsign generator for Arduino Uno
   Call PA3BNX
   With parameter Serial message 
   PTT trigger pin
   PTT transmissie output
   tone CW output 
   and CW key output
   5TVO
 */
#include "pitches.h"

// notes in the melody:
int melody[] = {
  NOTE_C4, NOTE_G3, NOTE_G3, NOTE_A3, NOTE_G3, 0, NOTE_B3, NOTE_C4
};

// note durations: 4 = quarter note, 8 = eighth note, etc.:
int noteDurations[] = {
  4, 8, 8, 4, 4, 4, 4, 4
};

//OutPut pins
const byte cPinCW=13;//CW key
const byte cPinCWtone=11; //Only allowed PWM 3,5,6,9,10,11
const byte cPinPTTled=3; //PTT tx hold pin Red led 
const byte cPinPTTbc547=4;//PTT BC547 to Rig


//Input pins
const byte cPinHi=8;//Hi play pin
const byte cPinMelody=9; //Melody play
const byte cPinTrigger=10;//Trigger Remember High = No trigger
const byte cPinMic=5;//Pin Klap Mic
const byte cPinPTTpressed=6;//Pin PTT Call Gever out of mic

//Bool
bool bWatchDog;
bool bStringComplete;
bool bPTTStartDownDone;

//Integer
int freq;
int stripe;
int dot;
int space;
int separator;
long callTime;
long startTime; 
long startTime1= millis()+2000;
int x;


//String
String inputString;

//Programs

void StartMessage()
{
 //Run this for easy StartUp messagwe
 Serial.println(F("Version 1.02"));
 Serial.println(F("-Input Pins"));
 Serial.print(F("Melody trigger pin="));
 Serial.println(cPinMelody);
 Serial.print(F("Hi trigger pin="));
 Serial.println(cPinHi);
 Serial.print(F("CW trigger pin="));
 Serial.println(cPinTrigger);
 Serial.print(F("Mic trigger pin="));
 Serial.println(cPinMic);
 Serial.print(F("PTT pressed on table Mic="));
 Serial.println(cPinPTTpressed);
 Serial.println(F("-Output Pins"));
 Serial.print(F("bc547 Melody + CW + Tone-send pin="));
 Serial.println(cPinPTTbc547);
 Serial.print(F("PTT tx busy Red Led pin="));
 Serial.println(cPinPTTled);
 Serial.print(F("CW key pin="));
 Serial.println(cPinCW);
 Serial.print(F("CW tone pin="));
 Serial.println(cPinCWtone);
 Serial.println(F("---Params"));
 Serial.print(F("CW tone freq="));
 Serial.println(freq);
 Serial.print(F("Delay sec's="));
 int i = callTime/1000;
 Serial.println(i);
}

void PlayMorse(String aa)
{
byte i;
String m;

for (i=0;i<aa.length();i++)
{
  Serial.print( aa.charAt(i));
  char myChar = aa.charAt(i);

  if (myChar == ' ')
  {
   m += '/';
  }
  else
  {
   m += " ";
  }
 
  switch (myChar){
  case 'a':
   m += ".-";
   break;
  case 'b':
   m += "-...";
   break;
  case 'c':
   m += "-.-.";
   break;
  case 'd':
   m += "-..";
   break;
  case 'e':
   m += ".";
   break;
  case 'f':
   m += "..-.";
   break;
  case 'g':
   m += "--.";
   break;
  case 'h':
   m += "....";
   break;
  case 'i':
   m += "..";
   break;
  case 'j':
   m += ".---";
   break;
  case 'k':
   m += "-.-";
   break;
  case 'l':
   m += ".-..";
   break;
  case 'm':
   m += "--";
   break;
  case 'n':
   m += "-.";
   break;
  case 'o':
   m += "---";
   break;
  case 'p':
   m += ".--."; 
   break;
  case 'q':
   m += "--.-";
   break;
  case 'r':
   m += ".-.";
   break;
  case 's':
   m += "...";
   break;
  case 't':
   m += "-";
   break;
  case 'u':
   m += "..-";
   break;
  case 'v':
   m += "...-";
   break;
  case 'w':
   m += ".--";
   break;
  case 'x':
   m += "-..-";
   break;
  case 'y':
    m += "-.--"; 
    break;
  case 'z':
   m += "--..";
   break;
  case '1':
   m += ".----";
   break;
  case '2':
   m += "..---"; 
   break;
  case '3':
   m += "...--";
   break;
  case '4':
   m += "....-"; 
   break;
  case '5':
   m += ".....";
   break;
  case '6':
   m += "-...."; 
   break;
  case '7':
   m += "--...";
   break;
  case '8':
   m += "---..";
   break;
  case '9':
   m += "----."; 
   break;
  case '0':
   m += "-----"; 
   break;
  case '?':
   m+="..--..";
   break;
  case '.':
   m+=".-.-.-";
   break;
  case ',':
   m+=".----.";
   break;
  case '/':
   m+="-..-.";
   break;
  case '\\':
   m+="-..-.";
   break;
  default:
   break;
  }
}
  m.replace(" /","/");
  for (i=0;i<m.length();i++)
  {
   switch (m.charAt(i))
   {
   case '.':
    sein(dot);
    break;
   case '-':
    sein(stripe);
    break;
   case ' ':
    sein(space);
    break;
   case '/':
    sein(separator);
   default:
    sein(separator);
    break; 
   }
  }
}

void serialEvent() {
  while (Serial.available()) {
    //get the new byte:
    char inChar=(char)Serial.read();
    // if the incoming character is a newline, set a flag
    // so the main loop can do something about it:
    if (inChar==13||inChar==10||inputString.length() > 45 ){
      bStringComplete=true;
     }
     else
     {
      //add it to the inputString:
      inputString+=inChar;
      inputString.toUpperCase();
    } 
  }
}


void TVO5(String f,int i)
//@16-08-2016
{
int fr; 
char myChar;
char myOld;
char myOld1='E';

 Serial.print(F("5TVO="));
 digitalWrite(cPinPTTbc547,HIGH);
 digitalWrite(cPinPTTled,HIGH);
 delay(100);

while (f.length() < 5) {f="0"+f;} 

for (x=0;x<f.length();x++)
{
  myChar = f.charAt(x);
  
  if (myChar=='E'){myChar==myOld1;}
  if (myChar==myOld){myChar=='E';} 
   
  switch (myChar)
  {
   case '0':
   fr=2400;
   break; 
  case '1':
   fr=1060;
   break;
  case '2':
   fr=1160;
   break; 
  case '3':
   fr=1270;
   break;
  case '4':
   fr=1400;
   break; 
  case '5':
   fr=1530;
   break;
  case '6':
   fr =1670;
   break; 
  case '7':
   fr=1830;
   break;
   case '8':
   fr=2000;
   break;
  case '9':
   fr=2200;
   break; 
  case 'A':
   fr=2800;
   break;
   case 'B5':
   fr=810;
   break;
  case 'C':
   fr =970;
   break; 
  case 'D':
   fr=886;
   break;
  case 'E':
   fr=2600;
   break; 
  case 'F':
   fr=1750;
   break;
  default:
   fr=0;
   break;
 } 
 tone(cPinCWtone,fr,i);
 delay(i-1);
 if (myOld!='E'){myOld1=myOld;}
 myOld=myChar;
}

digitalWrite(cPinPTTled,LOW);
digitalWrite(cPinPTTbc547,LOW);
Serial.println(f);
}


void JustTone(int f)
{
 if (f < 32) return;   
 Serial.print(F("Tone="));
 digitalWrite(cPinPTTbc547,HIGH);
 digitalWrite(cPinPTTled,HIGH);
 tone(cPinCWtone,f,2000); 
 delay(2000); 
 digitalWrite(cPinPTTled,LOW);
 digitalWrite(cPinPTTbc547,LOW);
 Serial.println(f);
}

void Melody()
{
  Serial.println(F("Melody"));
  digitalWrite(cPinPTTbc547,HIGH);
  digitalWrite(cPinPTTled,HIGH);
  
  delay(50);
  for (int thisNote = 0; thisNote < 8; thisNote++) {

    // to calculate the note duration, take one second
    // divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 800 / noteDurations[thisNote];
    tone(cPinCWtone, melody[thisNote], noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
    // stop the tone playing:
    noTone(cPinCWtone);
  }
  digitalWrite(cPinPTTled,LOW);
  digitalWrite(cPinPTTbc547,LOW);
}


void PTTremote(byte r)
{
  Serial.print(F("PTTremote="));
  Serial.println(r);
  switch(r)
{
case 0:
 digitalWrite(cPinPTTbc547,LOW);
 bWatchDog=false;
 break;
case 1:
 digitalWrite(cPinPTTbc547,HIGH);
 bWatchDog=true;
 break;
}
}

void Leader()// 3 x v sein
{
  int f=freq;
  for (int i=0;i<3;i++)
  {
  switch(i){
   case 0:
  freq=NOTE_G5;
  break;
   case 1:
  freq=NOTE_E5;
  break;
  case 2:
  freq=NOTE_C5;
  break;
 default:
  freq=f;
  } 
   PlayMorse("v");
  }
  PlayMorse(" ");
  freq=f; 
}  

void Trailer()
{
byte z=50;  
int i;
for (i=-150;i<250;i+=15)
{
 if (i<0)
  {
   tone(cPinCWtone,freq-i,z);
  }
 else
 {
  tone(cPinCWtone,freq+i,z);
 }
 delay(z-10);
}
 
 sein(space);
 tone(cPinCWtone,freq,space);
 sein(space);

}

void Mic()
{
Serial.println(F("Mic"));
byte i= 80;
byte j= 150;
digitalWrite(cPinPTTled,HIGH);
tone(cPinCWtone,NOTE_C4,i);
delay(j);
tone(cPinCWtone,NOTE_C4,i);
delay(j);
tone(cPinCWtone,NOTE_F4,i);
delay(j);
tone(cPinCWtone,NOTE_F4,i);
delay(j);
tone(cPinCWtone,NOTE_D4,i);
delay(j);
tone(cPinCWtone,NOTE_D4,i);
delay(j);
tone(cPinCWtone,NOTE_C4,i);
delay(j);
//tone(cPinCWtone,NOTE_D4,100);
//delay(105);
//tone(cPinCWtone,NOTE_C4,100);
//delay(105);

digitalWrite(cPinPTTled,LOW);
}

void Hi()
{
digitalWrite(cPinPTTbc547,HIGH);
digitalWrite(cPinPTTled,HIGH); 
delay(50);  
PlayMorse("hi ");
Serial.println();
digitalWrite(cPinPTTled,LOW);
digitalWrite(cPinPTTbc547,LOW);
}

void Callsign(bool b)
{

 if (b==true) {digitalWrite(cPinPTTbc547,HIGH);} 
 
x += 1;
digitalWrite(cPinPTTled,HIGH);//Switch PTT on
Serial.print (x);
Serial.print(' ');
delay(dot);
Leader();

byte l=55;
byte h=121;
  
Speed(random(l,h));
PlayMorse("p");
Speed(random(l,h));
PlayMorse("a");
Speed(random(l,h));
PlayMorse("3");
Speed(random(l,h));
PlayMorse("b");
Speed(random(l,h));
PlayMorse("n");
Speed(random(l,h));
PlayMorse("x");
Serial.println();

//Trailer();

digitalWrite(cPinPTTled,LOW);
if (b==true){digitalWrite(cPinPTTbc547,LOW);}  
Speed(60);

}//Last Callsign

void Speed(int s)
{
  dot=s;
  stripe=3 * dot;
  space=4 * dot;
  separator=6 * dot;
}  

void sein(int token)
{
if (token==space)
{   
 delay(space);
 }
  else if (token==separator)
  {
  delay(separator);
  }  
  else
  {
  //freq= 200 + (analogRead(A0)* 2);
  digitalWrite(cPinCW,HIGH);
  tone(cPinCWtone,freq,token);
  delay(token);
  digitalWrite(cPinCW,LOW);
  delay(dot);
  }
 }

// Initialise
void setup() {
   Serial.begin(9600);
   //initialise port cPins
   pinMode(cPinCW, OUTPUT);
   pinMode(cPinPTTled,OUTPUT);
   pinMode(cPinTrigger,INPUT_PULLUP);
   pinMode(cPinMelody,INPUT_PULLUP);
   pinMode(cPinHi,INPUT_PULLUP);
   pinMode(cPinPTTpressed,INPUT_PULLUP);  
   pinMode(cPinMic,INPUT); 
   
  Speed(60);
  freq = NOTE_G5;
  //callTime = 300000;  //mSecondes
  callTime = 300000;
  randomSeed(analogRead(1));
  startTime=millis()+callTime;
  StartMessage();
 }

// start loop
void loop() {
 
//Now the delay ca 300000 mSec or 300 Sec 5 Min
  
//Main time loop   
  
  long TimeNow = millis();
  bool x;

  x=digitalRead(cPinPTTpressed);
  if (x==LOW && bPTTStartDownDone==false) 
  {
   bPTTStartDownDone=true;
   startTime= millis()+45000 ;//Ofset time 15 Sec after PTT push
  }
  else if (x==HIGH) 
  {
   bPTTStartDownDone=false;
  }

  //Callsign sending after PTT 5 seconds
  if (startTime < TimeNow && bPTTStartDownDone == true)
  { 
   Callsign(false);
   startTime = millis()+callTime;
  }
    
  //CallSign sending every 5 minutes
  if (startTime < TimeNow) 
  {
   if (bWatchDog==true){PTTremote(0);}//Reset if to long on
   if(x==LOW)Callsign(false);
   startTime = millis()+callTime;
  }
    
  //Serial input Just every 2 sec orso ?
  if (startTime1 < TimeNow)
   {
   serialEvent();  
   if (bStringComplete==true)
   {
   
    if(inputString.indexOf("=")!=-1)
     { 
      inputString.toLowerCase();
      digitalWrite(cPinPTTbc547,HIGH);
      digitalWrite(cPinPTTled,HIGH);
      PlayMorse(inputString);
      Serial.println();
      digitalWrite(cPinPTTled,LOW);
      digitalWrite(cPinPTTbc547,LOW);
     }
    else if (inputString=="1")
    {
     PTTremote(1);
    }
    else if (inputString=="0")
    {
     PTTremote(0);
    }  
    else if(inputString=="C")
    {
     JustTone(1750);
    }  
    else if (inputString.indexOf("HZ")!= -1)
    {
     JustTone(inputString.toInt());
    }
    else if (inputString.indexOf("T")!=-1) 
     {
      String test=inputString.substring(0,  inputString.indexOf("T"));
      TVO5(test ,70);
     }
    else if (inputString.indexOf("R")!=-1)
     {
      String test=String(random(0,100000),DEC);
      TVO5(test,70);
     }
     inputString="";
     bStringComplete=false;
     startTime1=millis()+2000;   
    }  
   }
   
   //Voter routine   
   for (int j=0;j<1000;j++)
   {
   if (digitalRead(cPinMelody)==LOW){Melody();startTime=millis()+callTime;break;}
   if (digitalRead(cPinHi)==LOW){Hi();startTime=millis()+callTime;break;}  
   if (digitalRead(cPinTrigger)==LOW){Callsign(true);startTime=millis()+callTime;break;}
   if (digitalRead(cPinMic)==LOW){Mic();startTime=millis()+callTime;break;}
   delayMicroseconds(1); 
   }
 
 } //end of loop
